/*******************************************************************
*
* DESCRIPTION: Atomic Model livernode
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 25 Jan,2005
*
*******************************************************************/
#ifndef __LIVERNODE_H
#define __LIVERNODE_H
/** include files **/
#include "atomic.h" // class Atomic
#include "except.h" // class InvalidMessageException
/** declarations **/
class livernode : public Atomic
{
public:
livernode( const string &name = "LiverNode" ) ; // Default constructor
virtual string className() const;
protected:
Model &initFunction();
Model &externalFunction( const ExternalMessage & );
Model &internalFunction( const InternalMessage & );
Model &outputFunction( const InternalMessage & );
private:
//defining ports
const Port &Win ;
Port &Wout ;
//defining variables
Time preparationTime, time_zero;
int Value;
};
// ** inline ** //
inline
string livernode::className() const
{
return "livernode" ;
}
#endif //__LIVERNODE_H