/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeA
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeA.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeA::livernodeA( const string &name )
: Atomic( name )
, WinA( addInputPort( "WinA" ) )
, WoutA( addOutputPort( "WoutA" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeA::initFunction()
{
Value = 0;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeA::externalFunction( const ExternalMessage &msg )
{
//RECEIVES MESSAGES FROM WinA PORT
if ( msg.port() == WinA)
{//ASSIGNS INPUT TO Value
Value = msg.value();
holdIn(active,preparationTime);
cout<<"LiverNodeA Received: "<<Value <<" at time "<< msg.time()
<<endl;
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeA::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeA::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUT, CHOOSE APPROPRIATE OUTPUT
if(Value==1){
Value = 12;//Piruvato
}else if(Value==2){
Value = 6; //ATP
}else if(Value==3){
Value = 5; //ADP
}else if(Value==4){
Value = 7; //ATP
}else if(Value==5){
Value = 0; //NO OUTPUT
}
//DISPLAY OUTPUT AND SEND IT TO ANY CONNECTED NODES
cout<<"LiverNodeA Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutA, Value );
return *this;
}