/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeB
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeB.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeB::livernodeB( const string &name )
: Atomic( name )
, WinBX( addInputPort( "WinBX" ) )
, WinBY( addInputPort( "WinBY" ) )
, WinBZ( addInputPort( "WinBZ" ) )
, WoutB( addOutputPort( "WoutB" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeB::initFunction()
{
Value = 0;
ValueX = 100;
ValueY = 100;
ValueZ = 100;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeB::externalFunction( const ExternalMessage &msg )
{
//RECEIVES MESSAGES FROM WinBX PORT
if ( msg.port() == WinBX)
{
//ASSIGNS INPUT TO ValueX
ValueX = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeB Received on port X: "<<ValueX <<" at time "<<
msg.time() <<endl;
//RECEIVES MESSAGES FROM WinBY PORT
}else if ( msg.port() == WinBY) {
//ASSIGNS INPUT TO ValueY
ValueY = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeB Received on port Y: "<<ValueY <<" at time
"<< msg.time() <<endl;
//RECEIVES MESSAGES FROM WinBZ PORT
}else if ( msg.port() == WinBZ) {
//ASSIGNS INPUT TO ValueZ
ValueZ = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeB Received on port Z: "<<ValueZ <<" at time
"<< msg.time() <<endl;
}
//ONCE ALL INPUT PORTS HAVE RECEIVED INPUTS, CALCULATE OUTPUT
if(ValueX != 100 && ValueY != 100 && ValueZ != 100){
holdIn(active,preparationTime);
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeB::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeB::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUTS, CHOOSE APPROPRIATE OUTPUT
if(ValueX==12 && ValueY ==1 && ValueZ == 6){//reaction 1
	Value=7;//Oxaloacetato
}else if(ValueX==6 && ValueY ==2 && ValueZ == 0){//reaction 2
Value=8;//Glucose-6-P
}else if(ValueY ==3 && ValueZ == 0){//reaction 3
Value=0;//NO OUTPUT
}else if(ValueY == 4 && ValueZ == 0){//reaction 4
Value=0;//NO OUTPUT
}else if(ValueX==0 && ValueY ==5 && ValueZ == 0){//reaction 5
Value=0;//NO OUTPUT
}
//DISPLAY OUTPUT AND SEND IT TO ANY CONNECTED NODES
cout<<"LiverNodeB Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutB, Value );
return *this;
}