/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeC
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeC.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeC::livernodeC( const string &name )
: Atomic( name )
, WinC( addInputPort( "WinC" ) )
, WoutC( addOutputPort( "WoutC" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeC::initFunction()
{
Value = 0;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeC::externalFunction( const ExternalMessage &msg )
{
//RECEIVES MESSAGES FROM WinC PORT
if ( msg.port() == WinC)
{
	//ASSIGNS INPUT TO Value
Value = msg.value();
holdIn(active,preparationTime);
cout<<"LiverNodeC Received: "<<Value <<" at time "<< msg.time()
<<endl;
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeC::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeC::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUT, CHOOSE APPROPRIATE OUTPUT
if(Value==1){
Value = 6; //ATP
}else if(Value==2){
Value = 0; //NO OUTPUT
}else if(Value==3){
Value = 0; //NO OUTPUT
}else if(Value==4){
Value = 0; //NO OUTPUT
}else if(Value==5){
Value = 0; //NO OUTPUT
}
//DISPLAY OUTPUT AND SEND IT TO ANY CONNECTED NODES
cout<<"LiverNodeC Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutC, Value );
return *this;
}