/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeD
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeD.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeD::livernodeD( const string &name )
: Atomic( name )
, WinDX( addInputPort( "WinDX" ) )
, WinDY( addInputPort( "WinDY" ) )
, WoutD( addOutputPort( "WoutD" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeD::initFunction()
{
Value = 0;
ValueX = 100;
ValueY = 100;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeD::externalFunction( const ExternalMessage &msg )
{
//RECEIVES MESSAGES FROM WinDX PORT
if ( msg.port() == WinDX)
{
//ASSIGNS INPUT TO ValueX
ValueX = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeD Received on port X: "<<ValueX <<" at time "<<
msg.time() <<endl;
//RECEIVES MESSAGES FROM WinDY PORT
}else if ( msg.port() == WinDY)
{
//ASSIGNS INPUT TO ValueY
ValueY = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeD Received on port Y: "<<ValueY <<" at time "<<
msg.time() <<endl;
}
//ONCE ALL INPUT PORTS HAVE RECEIVED INPUTS, CALCULATE OUTPUT
if(ValueX != 100 && ValueY != 100){
holdIn(active,preparationTime);
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeD::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeD::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUTS, CHOOSE APPROPRIATE OUTPUT
if(ValueX==1){// reaction 1
Value = 1; //NADH + H+
}else if(ValueX==2 ){// reaction 2
Value = 2; //UDP
}else if(ValueX==3 && ValueY ==5){// reaction 3
Value = 9; //piruvato
}else if(ValueX==4 && ValueY ==7){// reaction 4
Value = 10; //Frutose-1,6-BP
}else if(ValueX==11 && ValueY ==0){// reaction 5
Value = 11; //Glucose-6-P
}
//DISPLAY OUTPUT AND SEND IT TO ANY CONNECTED NODES
cout<<"LiverNodeD Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutD, Value );
return *this;
}