/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeE
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeE.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeE::livernodeE( const string &name )
: Atomic( name )
, WinEX( addInputPort( "WinEX" ) )
, WinEY( addInputPort( "WinEY" ) )
, WoutE( addOutputPort( "WoutE" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeE::initFunction()
{
Value = 0;
ValueX = 100;
ValueY = 100;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeE::externalFunction( const ExternalMessage &msg )
{
	//RECEIVES MESSAGES FROM WinEX PORT
if ( msg.port() == WinEX)
{
//ASSIGNS INPUT TO ValueX
ValueX = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeE Received on port X: "<<ValueX <<" at time "<<
msg.time() <<endl;
//RECEIVES MESSAGES FROM WinEY PORT
}else if ( msg.port() == WinEY)
{
//ASSIGNS INPUT TO ValueY
ValueY = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeE Received on port Y: "<<ValueY <<" at time "<<
msg.time() <<endl;
}
//ONCE ALL INPUT PORTS HAVE RECEIVED INPUTS, CALCULATE OUTPUT
if(ValueX != 100 && ValueY != 100){
holdIn(active,preparationTime);
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeE::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeE::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUTS, CHOOSE APPROPRIATE OUTPUT
if(ValueX==7){//reaction 1
Value = 7; //Oxaloacetato
}else if(ValueX==8 && ValueY ==0){//reaction 2
Value = 5; //Glucose-1-P
}else if(ValueX==0 && ValueY ==0){//reaction 3 and 4 and 5
Value = 0; //NO OUTPUT
}
//DISPLAY OUTPUT AND SEND IT TO ANY CONNECTED NODES
cout<<"LiverNodeE Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutE, Value );
return *this; }