/*******************************************************************
*
* DESCRIPTION: Atomic Model of livernodeF
*
* AUTHOR: Alexander Dias, Banan Al-Aubiydy
*
* DATE: 24 Jan,2005
*
*******************************************************************/
#include "liverNodeF.h" // base header
#include "message.h" // InternalMessage ....
#include "mainsimu.h" // class MainSimulator
#include "strutil.h" // str2Value(...)
/*******************************************************************
* Function Name: livernode
* Description: constructor
********************************************************************/
livernodeF::livernodeF( const string &name )
: Atomic( name )
, WinFX( addInputPort( "WinFX" ) )
, WinFY( addInputPort( "WinFY" ) )
, WinFZ( addInputPort( "WinFZ" ) )
, WoutF( addOutputPort( "WoutF" ) )
, preparationTime( 0, 0, 5, 0 )
, time_zero( 0, 0, 3, 0)
{
string time( MainSimulator::Instance().getParameter(
description(), "preparation" ) ) ;
if( time != "" )
preparationTime = time ;
}
/*******************************************************************
* Function Name: initFunction
********************************************************************/
Model &livernodeF::initFunction()
{
Value = 0;
ValueX = 100;
ValueY = 100;
ValueZ = 100;
return *this ;
}
/*******************************************************************
* Function Name: externalFunction
********************************************************************/
Model &livernodeF::externalFunction( const ExternalMessage &msg )
{
//RECEIVES MESSAGES FROM WinFX PORT
if ( msg.port() == WinFX)
{
//ASSIGNS INPUT TO ValueX
ValueX = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeF Received on port X: "<<ValueX <<" at time "<<
msg.time() <<endl;
//RECEIVES MESSAGES FROM WinFY PORT
}else if ( msg.port() == WinFY) {
//ASSIGNS INPUT TO ValueY
ValueY = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeF Received on port Y: "<<ValueY <<" at time "<<
msg.time() <<endl;
//RECEIVES MESSAGES FROM WinFZ PORT
}else if ( msg.port() == WinFZ) {
//ASSIGNS INPUT TO ValueX
ValueZ = msg.value();
//holdIn(active,preparationTime);
cout<<"LiverNodeF Received on port Z: "<<ValueZ <<" at time "<<
msg.time() <<endl;
}
//ONCE ALL INPUT PORTS HAVE RECEIVED INPUTS, CALCULATE OUTPUT
if(ValueX != 100 && ValueY != 100 && ValueZ != 100){
holdIn(active,preparationTime);
}
return *this ;
}
/*******************************************************************
* Function Name: internalFunction
********************************************************************/
Model &livernodeF::internalFunction( const InternalMessage & )
{
passivate();
return *this;
}
/*******************************************************************
* Function Name: outputFunction
********************************************************************/
Model &livernodeF::outputFunction( const InternalMessage &msg )
{
//BASED ON INPUTS, CHOOSE APPROPRIATE OUTPUT
if(ValueX==1 && ValueZ == 7){//reaction 1
Value=5;//Glucose-1-P
}else if(ValueX==2 && ValueZ == 5){//reaction 2
Value=3;//UDP-glucose
}else if(ValueX==9 && ValueZ == 0){//reaction 3
Value=9;//piruvato
}else if(ValueX==10 && ValueZ == 0){//reaction 4
Value=10;//Frutose-1,6-BP
}else if(ValueX==11 && ValueY == 0 && ValueZ == 0){//reaction 5
Value=6;//Pi + Glucose
}
//DISPLAY OUTPUT
cout<<"LiverNodeF Produced: "<<Value<<" at time "<<
msg.time()<<endl;
sendOutput( msg.time(), WoutF, Value );
return *this;
}